use std::cell::RefCell;
use std::rc::Rc;
use crate::cpu::Cpu;
use crate::memory::MemoryBus;

pub struct System {
    cpu: Cpu,
    memory_bus: Rc<RefCell<MemoryBus>>,
}

impl System {
    pub fn new() -> Self {
        let memory_bus = Rc::new(RefCell::new(MemoryBus::new()));
        let cpu = Cpu::new(memory_bus);
        
        Self {
            cpu,
            memory_bus
        }
    }
}